"use strict";
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
if (typeof Symbol.asyncIterator === undefined) {
    // Create the symbol async iterator if it is undefined
    // @ts-ignore
    Symbol.asyncIterator = Symbol('Symbol.asyncIterator');
}
class LineFileReader {
    constructor(file) {
        this.file = file;
        if (!LineFileReader.isFile(file)) {
            throw new Error("This object is not a file");
        }
    }
    static isFile(data) {
        if (typeof Blob !== 'undefined') {
            return data instanceof Blob;
        }
        return false;
    }
    /** Iterate a file line by line */
    [Symbol.asyncIterator]() {
        return __asyncGenerator(this, arguments, function* _a() {
            let seeker = 0;
            let buffer = "";
            // While we didn't reach the end of file
            while (seeker < this.file.size) {
                const part = yield __await(this.file.slice(seeker, seeker + LineFileReader.CHUNK_LENGTH).text());
                seeker += LineFileReader.CHUNK_LENGTH;
                const parts = part.split('\n');
                if (parts.length > 1) {
                    // There is a next line
                    parts[0] = buffer + parts[0];
                    // Store the remaining line in the buffer
                    buffer = parts[parts.length - 1];
                    for (const line of parts.slice(0, parts.length - 1)) {
                        yield yield __await(line);
                    }
                }
                else {
                    // There is no next line here. Save the whole chunk in the buffer.
                    buffer += part;
                }
            }
            // If buffer is filled, this is the last line. Emit it !
            if (buffer) {
                yield yield __await(buffer);
            }
        });
    }
}
exports.LineFileReader = LineFileReader;
/** Read by chunks of 1 KB of text */
LineFileReader.CHUNK_LENGTH = 1024;
exports.default = LineFileReader;
